Package: groovy.org.codenarc

## [Groovy] Class CodeNarc

- groovy.org.codenarc.CodeNarc

- Command-line runner for CodeNarc.

  The supported command-line parameters are all of the form: "-OPTION=VALUE", where OPTION is one of the options in the following list.
  - help - Display the command-line help; If present, this must be the only command-line parameter.
  - basedir - The base directory for the source code to be analyzed. This is the root of the directory tree. Defaults to the current directory ('.').
  - rulesetfiles - The path to the Groovy or XML RuleSet definition files, relative to the classpath. This can be a single file path, or multiple paths separated by commas. Defaults to "rulesets/basic.xml".
  - includes - The comma-separated list of Ant file patterns specifying files that must be included; all files are included when omitted.
  - excludes - The comma-separated list of Ant file patterns specifying files that must be excluded; no files are excluded when omitted.
  - title - The title description for this analysis; used in the output report(s). Optional.
  - report - The definition of the report to produce. The option value is of the form TYPE[:FILENAME]. where TYPE is 'html' and FILENAME is the filename (with optional path) of the output report filename. If the report filename is omitted, the default filename is used ("CodeNarcReport.html"). If no report option is specified, defaults to a single 'html' report with the default filename.
  Authors:
    Chris Mair

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static def` | `HELP` |
    `protected String` | `baseDir` |
    `protected def` | `createCodeNarcRunner` |
    `protected String` | `excludes` |
    `protected String` | `includes` |
    `protected List` | `reports` |
    `protected String` | `ruleSetFiles` |
    `protected static def` | `systemExit` |
    `protected String` | `title` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected SourceAnalyzer` | `createSourceAnalyzer()` Create and return the SourceAnalyzer
    `` | `protected void` | `execute(String[] args)`
    `` | `static void` | `main(String[] args)` Main command-line entry-point.
    `` | `protected void` | `parseArgs(String[] args)`
    `` | `protected void` | `setDefaultsIfNecessary()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected static final def HELP

    - #### protected String baseDir

    - #### protected def createCodeNarcRunner

    - #### protected String excludes

    - #### protected String includes

    - #### protected List reports

    - #### protected String ruleSetFiles

    - #### protected static def systemExit

    - #### protected String title

  - ### Method Detail

    - #### protected SourceAnalyzer createSourceAnalyzer()

      Create and return the SourceAnalyzer

      Returns:
        a configured SourceAnalyzer instance

    - #### protected void execute(String[] args)

    - #### static void main(String[] args)

      Main command-line entry-point. Run the CodeNarc application.

      Parameters:
        `args` - - the String[] of command-line arguments

    - #### protected void parseArgs(String[] args)

    - #### protected void setDefaultsIfNecessary()